/* * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef _CASTASTESTER_HPP
#define _CASTASTESTER_HPP

#include <xercesc/util/XercesDefs.hpp>
#include "DatatypeTester.hpp"

class DynamicContext;
class XPath2MemoryManager;
class ATAnyURIOrDerived;
class ATBase64BinaryOrDerived;
class ATBooleanOrDerived;
class ATDateOrDerived;
class ATDateTimeOrDerived;
class ATDecimalOrDerived;
class ATDoubleOrDerived;
class ATDurationOrDerived;
class ATFloatOrDerived;
class ATGDayOrDerived;
class ATGMonthOrDerived;
class ATGMonthDayOrDerived;
class ATGYearMonthOrDerived;
class ATGYearOrDerived;
class ATHexBinaryOrDerived;
class ATQNameOrDerived;
class ATStringOrDerived;
class ATTimeOrDerived;
class ATUntypedAtomic;

/**
 * Tests CastAs for all datatypes
 */
class CastAsTester: public DatatypeTester {
public: 
  CastAsTester(XPath2MemoryManager* memMgr);
   
  // use default
  // virtual void init();

  virtual void run(const DynamicContext* context);
  
  // use default
  // virtual void wrapUp();

protected:
  const ATAnyURIOrDerived* createURI(const XMLCh* value, const DynamicContext* context);
  const ATBase64BinaryOrDerived* createBinary(const XMLCh* value, const DynamicContext* context);
  const ATBooleanOrDerived* createBoolean(const XMLCh* value, const DynamicContext* context);
  const ATGDayOrDerived* createGDay(const XMLCh* value, const DynamicContext* context);
  const ATDurationOrDerived* createDuration(const XMLCh* value, const DynamicContext* context);
  const ATHexBinaryOrDerived* createHexBinary(const XMLCh* value, const DynamicContext* context);
  const ATGMonthDayOrDerived* createGMonthDay(const XMLCh* value, const DynamicContext* context);
  const ATGMonthOrDerived* createGMonth(const XMLCh* value, const DynamicContext* context);
  const ATQNameOrDerived* createQName(const XMLCh* value, const DynamicContext* context);
  const ATStringOrDerived* createString(const XMLCh* value, const DynamicContext* context);
  const ATGYearMonthOrDerived* createGYearMonth(const XMLCh* value, const DynamicContext* context);
  const ATGYearOrDerived* createGYear(const XMLCh* value, const DynamicContext* context);
};


#endif // _CASTASTESTER_HPP
