/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*

  XPathParseException - exception class for DSLPath parser

*/

#ifndef _XPATHPARSEEXCEPTION_HPP
#define _XPATHPARSEEXCEPTION_HPP



#include <pathan/exceptions/DSLException.hpp>
#include <pathan/internal/DOMutils/XStr.hpp>

/** exception class for DSLPath parser */
class PATHAN_EXPORT XPathParseException : public DSLException
{
public:

  XPathParseException(const XMLCh* const functionName, const XMLCh* const reason, const char *file, int line)
    : DSLException(X("XPathParseException"), functionName, reason, file, line) {};
};

#endif // _XPATHPARSEEXCEPTION_HPP

