#include "../config/pathan_config.h"
/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include <pathan/functions/FunctionData.hpp>
#include <pathan/Node.hpp>
#include <pathan/Item.hpp>
#include <pathan/exceptions/FunctionException.hpp>
#include <pathan/DynamicContext.hpp>

const XMLCh FunctionData::name[] = {
XERCES_CPP_NAMESPACE_QUALIFIER chLatin_d, XERCES_CPP_NAMESPACE_QUALIFIER chLatin_a, XERCES_CPP_NAMESPACE_QUALIFIER chLatin_t, XERCES_CPP_NAMESPACE_QUALIFIER chLatin_a, XERCES_CPP_NAMESPACE_QUALIFIER chNull };

/*
 * fn:data($arg as item()*) as xdt:anyAtomicType*
 */

FunctionData::FunctionData(const VectorOfDataItems &args, XPath2MemoryManager* memMgr)
  : ConstantFoldingFunction(name,1, 1, "item()*", args, memMgr)
{
}

Sequence FunctionData::collapseTreeInternal(DynamicContext* context, int flags) const
{
	Sequence items=getParamNumber(1,context);

  Sequence result(items.getLength(), context->getMemoryManager());
  Sequence::iterator end = items.end();
  for(Sequence::iterator i = items.begin(); i != end; ++i) {
    const Item* item = *i;
    if(item->isNode())
    {
      const Node* node = (const Node*)item;
      result.joinSequence(node->dmTypedValue(context));
    }
    else
      result.addItem(item);
  }
  return result;
}
















