#include "../config/pathan_config.h"
/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include <pathan/internal/navigation/AncestorOrSelfAxis.hpp>
#include <xercesc/dom/DOMNode.hpp>
#include <pathan/Node.hpp>

NavStepImpl::Axis AncestorOrSelfAxis::getAxis() const {
  return NavStepImpl::ANCESTOR_OR_SELF;
}

Sequence AncestorOrSelfAxis::makeList(const XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, const XMLCh* const uri, DynamicContext* context) const
{
  XPath2MemoryManager* memMgr=context->getMemoryManager();
  Sequence ancestorList=AncestorAxis::makeList(node,uri,context);

  if(filterNode(node,uri,context))
    ancestorList.addItem(memMgr->createNode(node));

  return ancestorList;
}

