#include "../config/pathan_config.h"
/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include <pathan/internal/navigation/AttributeAxis.hpp>
#include <pathan/XPath2Utils.hpp>
#include <pathan/Node.hpp>
#include <xercesc/util/XMLUni.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOMNode.hpp>
#include <xercesc/dom/DOMNamedNodeMap.hpp>

NavStepImpl::Axis AttributeAxis::getAxis() const {
  return NavStepImpl::ATTRIBUTE;
}

Sequence AttributeAxis::makeList(const XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, const XMLCh* const uri, DynamicContext* context) const
{
  XPath2MemoryManager* memMgr=context->getMemoryManager();

  XERCES_CPP_NAMESPACE_QUALIFIER DOMNamedNodeMap *nodeMap = node -> getAttributes();

  Sequence resultSeq(memMgr);

  if (nodeMap == 0)
    return resultSeq;

  for (unsigned int i = 0; i < nodeMap -> getLength(); i++){
    XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* attr=nodeMap->item(i);
    if(!XERCES_CPP_NAMESPACE_QUALIFIER XMLString::equals(attr->getNamespaceURI(),XERCES_CPP_NAMESPACE_QUALIFIER XMLUni::fgXMLNSURIName) &&
       filterNode(attr,uri,context))
      resultSeq.addItem(memMgr->createNode(attr));
  }

  return resultSeq;
}//makeList

