#include "../config/pathan_config.h"
/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include <pathan/internal/navigation/DescendantOrSelfAxis.hpp>
#include <pathan/Node.hpp>

NavStepImpl::Axis DescendantOrSelfAxis::getAxis() const {
  return NavStepImpl::DESCENDANT_OR_SELF;
}

Sequence DescendantOrSelfAxis::makeList(const XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, const XMLCh* const uri, DynamicContext* context) const
{
  XPath2MemoryManager* memMgr=context->getMemoryManager();
  Sequence returnList(memMgr);
  if(filterNode(node, uri, context))
    returnList.addItem(memMgr->createNode(node));
  makeListHelper(node, &returnList, uri, context);

  return returnList;
}//makeList

