#include "../config/pathan_config.h"
/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include <pathan/internal/navigation/ParentAxis.hpp>
#include <xercesc/dom/DOMNode.hpp>
#include <xercesc/dom/DOMAttr.hpp>
#include <xercesc/dom/DOMElement.hpp>
#include <xercesc/dom/DOMXPathNamespace.hpp>
#include <pathan/Node.hpp>

NavStepImpl::Axis ParentAxis::getAxis() const {
  return NavStepImpl::PARENT;
}

Sequence ParentAxis::makeList(const XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, const XMLCh* const uri, DynamicContext* context) const
{
  XPath2MemoryManager* memMgr=context->getMemoryManager();

  XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* parentNode=0;
  if(node->getNodeType() == XERCES_CPP_NAMESPACE_QUALIFIER DOMNode::ATTRIBUTE_NODE) {

    const XERCES_CPP_NAMESPACE_QUALIFIER DOMAttr *domAttr = static_cast<const XERCES_CPP_NAMESPACE_QUALIFIER DOMAttr *>(node);
    parentNode=domAttr->getOwnerElement();
  }
  else if(node->getNodeType() == XERCES_CPP_NAMESPACE_QUALIFIER DOMXPathNamespace::XPATH_NAMESPACE_NODE)
    parentNode=0;
  else
    parentNode=node->getParentNode();

  Sequence retList(memMgr);
  if(parentNode!=0 && filterNode(parentNode, uri, context))
    retList.addItem(memMgr->createNode(parentNode));
  return retList;
}//makeList
