#include "../config/pathan_config.h"
/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include <pathan/internal/navigation/ReverseAxis.hpp>
#include <xercesc/dom/DOMAttr.hpp>
#include <xercesc/dom/DOMElement.hpp>

ReverseAxis::ReverseAxis() 
{
  setAxisOrientation(REVERSE);
}

XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *ReverseAxis::getParent(const XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node) const
{
  switch(node->getNodeType()) {
    
  case XERCES_CPP_NAMESPACE_QUALIFIER DOMNode::TEXT_NODE:
  case XERCES_CPP_NAMESPACE_QUALIFIER DOMNode::COMMENT_NODE:
  case XERCES_CPP_NAMESPACE_QUALIFIER DOMNode::ELEMENT_NODE:
    return node->getParentNode();
    break;

  case XERCES_CPP_NAMESPACE_QUALIFIER DOMNode::ATTRIBUTE_NODE:
    return static_cast<const XERCES_CPP_NAMESPACE_QUALIFIER DOMAttr *>(node)->getOwnerElement();
    break;
  default:
    return 0;
    break;
  }
}

