#include "../config/pathan_config.h"
/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include <assert.h>
#include <pathan/operators/OrderComparison.hpp>
#include <pathan/Node.hpp>
#include <pathan/ATBooleanOrDerived.hpp>
#include <pathan/DynamicContext.hpp>
#include <pathan/internal/factory/DatatypeFactory.hpp>

/*static*/ const XMLCh OrderComparison::name[]={ XERCES_CPP_NAMESPACE_QUALIFIER chLatin_n, XERCES_CPP_NAMESPACE_QUALIFIER chLatin_o, XERCES_CPP_NAMESPACE_QUALIFIER chLatin_d, XERCES_CPP_NAMESPACE_QUALIFIER chLatin_e, XERCES_CPP_NAMESPACE_QUALIFIER chDash, XERCES_CPP_NAMESPACE_QUALIFIER chLatin_o, XERCES_CPP_NAMESPACE_QUALIFIER chLatin_r, XERCES_CPP_NAMESPACE_QUALIFIER chLatin_d, XERCES_CPP_NAMESPACE_QUALIFIER chLatin_e, XERCES_CPP_NAMESPACE_QUALIFIER chLatin_r, XERCES_CPP_NAMESPACE_QUALIFIER chNull };

OrderComparison::OrderComparison(const VectorOfDataItems &args, bool testBefore, XPath2MemoryManager* memMgr)
  : DataItemOperator(name, args, memMgr)
{
	_testBefore = testBefore;
}

Sequence OrderComparison::collapseTreeInternal(DynamicContext* context, int flags) const
{
	XPath2MemoryManager* memMgr = context->getMemoryManager();

	const Node* arg1 = getNodeParam(0,context);
  if(arg1==0)
    return Sequence(memMgr);
	const Node* arg2 = getNodeParam(1,context);
  if(arg2==0)
    return Sequence(memMgr);

	if(_testBefore)
    return Sequence(DatatypeFactory::POD2AT::createBoolean(context->getMemoryManager(), arg1->lessThan(arg2), context), context->getMemoryManager());
	else
    return Sequence(DatatypeFactory::POD2AT::createBoolean(context->getMemoryManager(), arg2->lessThan(arg1), context), context->getMemoryManager());
}

